local M = {}

local device = nil

local timer = 0
local timer2 = 0

local oilpressureSmoother = newTemporalSigmoidSmoothing(2, 6, 2, 6, 0)
local fuelSmoother = newTemporalSigmoidSmoothing(2, 6, 2, 6, 0)

--reset values on vehicle init
local function onInit()

    local timer = 0
    local timer2 = 0
    electrics.values.fuelGauge = electrics.values.fuel
    electrics.values.oilpressureGauge = 1
    electrics.values.Golf1signalAmper = 0
    electrics.values.seatbelt = 0
    electrics.values.oilpress = 0
    device = powertrain.getDevice("mainEngine")
    --sounds.createSFXSource("art/sound/gauges_beep.ogg", 'AudioDefault3D', "GaugesBeep", 330)

end

--reset values on vehicle reset
local function onReset()

    local timer = 0
    local timer2 = 0
    electrics.values.fuelGauge = electrics.values.fuel
    electrics.values.oilpressureGauge = 1
    electrics.values.Golf1signalAmper = 0
    electrics.values.seatbelt = 0
    electrics.values.oilpress = 0
    device = powertrain.getDevice("mainEngine")

end

local function updateGFX(dt)

    if device.starterEngagedCoef ~= 0 and not device.isDisabled then        --check if starter is running
        
        if electrics.values.amps < 3 then
            electrics.values.Golf1signalAmper = 1
        else
            electrics.values.Golf1signalAmper = 0
        end


        electrics.values.seatbelt = 1
        electrics.values.oilpress = 1

        sounds.playSoundOnceAtNode("GaugesBeep", 330, 4)

    
    elseif electrics.values["engineRunning"] == 1 then      --check if engine is running, timers for seatbelt and oil pressure, amps to Golf1signalAmper

        timer = timer + dt
        if timer >= 2 then
    
            electrics.values.seatbelt = 0
            timer = 0

        end

        timer2 = timer2 + dt
        if timer2 >= 1.5 then

            electrics.values.oilpress = 0
            timer2 = 0
        end

        if electrics.values.amps < 3 then
            electrics.values.Golf1signalAmper = 1
        else
            electrics.values.Golf1signalAmper = 0
        end

    elseif electrics.values["engineRunning"] == 0 then      --check if engine is running, set oil press
        

        electrics.values.Golf1signalAmper = 0

    end  

    if electrics.values["engineRunning"] == 0 then

        electrics.values.fuelGauge = 0
        electrics.values.oilpressureGauge = 0

    else

        electrics.values.fuelGauge = electrics.values.fuel
        electrics.values.oilpressureGauge = 1

    end

    electrics.values.fuelGauge = fuelSmoother:get(electrics.values.fuelGauge or 0, dt)
    electrics.values.oilpressureGauge = oilpressureSmoother:get(electrics.values.oilpressureGauge or 0, dt)
end

-- public interface
M.onInit = onInit
M.onReset = onReset
M.updateGFX = updateGFX

return M