local M = {}

local min = math.min
local max = math.max

local dischargeRate = 5
local chargeEfficiency = 2

local ampsSmoother = newTemporalSigmoidSmoothing(50, 70, 50, 70, 0)

local function onInit()
    device = powertrain.getDevice("mainEngine")
    electrics.values.amps = 1
end

local function onReset()
    electrics.values.amps = 1
end


local function updateGFX(dt)

    if device.starterEngagedCoef ~= 0 then

        electrics.values.amps = 17

    elseif electrics.values["engineRunning"] == 1 then

        if electrics.values.rpm < 800 then
        
            electrics.values.amps = electrics.values.amps + (electrics.values.rpm / chargeEfficiency) * 0.000000000010

        else

            electrics.values.amps = ((electrics.values.amps + (electrics.values.rpm * electrics.values.rpm) / (chargeEfficiency / electrics.values.rpm)) * 0.000000000010) + 12
        end

    else

        electrics.values.amps = electrics.values.amps - electrics.values.amps / dischargeRate

    end

    electrics.values.amps = ampsSmoother:get(electrics.values.amps or 0, dt)

end
-- public interface
M.updateGFX = updateGFX
M.onInit = onInit
M.onReset = onReset

return M